
QGIS Application - Bug report #8002

Voronoi Polygons tool makes overlapped polygons

2013-06-05 03:24 AM - dr -

Status: Closed

Priority: Normal

Assignee:

Category: Processing/QGIS

Affected QGIS version:3.0.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 16852

Description

1) Open vector layer garden-nodes-merc1.shp (in attachment);

2) Build Voronoi Polygons using appropriate tool;

3) Change transparency of layer to 50%;

In result you can see that some of adjacent polygon are overlapped

Related issues:

Duplicated by QGIS Application - Bug report # 18212: Voronoi creates overlapp... Rejected 2018-02-24

Associated revisions

Revision 28fa839a - 2018-08-07 08:52 PM - Håvard Tveite

[processing] Update to VoronoiPolygons.py, some fixes for #8002

    -  Update to VoronoiPolygons.py, fixes #8002 adds comments, ++

    -  Fixed a spelling an an indentation mistake reported by travis

    -  Found some new cases (vertical line clipping and a mistake in the handling of extreme points)

Revision acbb27c2 - 2018-08-08 11:28 AM - Håvard Tveite

[processing] Update to VoronoiPolygons.py, some fixes for #8002

    -  Update to VoronoiPolygons.py, fixes #8002 adds comments, ++

    -  Fixed a spelling an an indentation mistake reported by travis

    -  Found some new cases (vertical line clipping and a mistake in the handling of extreme points)

(cherry-picked from 28fa839a0)

Revision d2b71c30 - 2018-08-09 01:18 AM - Håvard Tveite

[processing] Added isclose function to VoronoyPolygons.py to avoid numerical instability

Fixes #8002 - hopefully, and adds tests
Revision 7c2a9982 - 2018-08-09 03:48 AM - Håvard Tveite

[processing] Added isclose function to VoronoyPolygons.py to avoid numerical instability

Fixes #8002 - hopefully, and adds tests

(cherry-picked from d2b71c30)

History

#1 - 2013-06-05 03:50 AM - Maxim Dubinin

f1f17ed

works good for me (with 5% buffer and without)

#2 - 2013-06-05 03:53 AM - dr -

- File voronoi-issue.png added

- Operating System set to Windows

Update QGIS to current master 5e29777 and get the same issue.

#3 - 2013-06-05 11:45 AM - Giovanni Manghi

- Status changed from Open to Feedback

result is ok here too (master/linux).

#4 - 2013-07-14 08:47 AM - Daniel Vaz

I can't reproduce this bug. Probably it was fixed in meanwhile.

I think that issue should be closed.

Thanks in advance.

#5 - 2013-07-14 09:20 AM - Giovanni Manghi

- Resolution set to worksforme

- Status changed from Feedback to Closed

Closing for lack of feedback and because seems ok now, please reopen if necessary.

#6 - 2013-09-05 03:25 AM - Giles Collingwood

- File Capture2.PNG added

- File london.geojson added

- Status changed from Closed to Reopened
Hi I managed to reproduce this issue with a very small data set of 14 points on the master version today (QGIS-OSGeo4W-1.9.0-35-Setup.exe) attached a

screenshot showing the overlapping polygon selected and the data file that generated it.

#7 - 2014-03-27 07:17 AM - Anita Graser

- Category changed from Vectors to 44

- Resolution deleted (worksforme)

You can easily replicate the issue using the airports dataset from QGIS sample dataset. It creates overlapping polygons if used from the Vector menu as

well as in processing.

#8 - 2015-07-15 04:47 PM - Andrew Bevitt

- File voronoi.patch added

- File voronoi_patched.png added

- File voronoi_errors.png added

This is still an issue in 2.8* and the master branch. This issue stems from the line clipping function incorrectly calculating intercept points for the buffer

boundary. Attached is a patch to correct this and two example images before and after (5% buffer applied). In the images the Voronoi layer has 50%

transparency. In the before the darker pinky/purple areas are where the polygons are overlapping. In the after there is no such darker (green) region.

#9 - 2015-07-31 10:58 AM - Giovanni Manghi

- Operating System deleted (Windows)

- Pull Request or Patch supplied changed from No to Yes

Andrew Bevitt wrote:

This is still an issue in 2.8* and the master branch. This issue stems from the line clipping function incorrectly calculating intercept points for the

buffer boundary. Attached is a patch to correct this and two example images before and after (5% buffer applied). In the images the Voronoi layer

has 50% transparency. In the before the darker pinky/purple areas are where the polygons are overlapping. In the after there is no such darker

(green) region.

Many thanks for this patch! I tested it and it produces much better outputs, for example fixes the issue described here #13092.

Anyway there are point layers where still overlapping polygons are produced, for example the "airports" shape of the qgis sample dataset.

#10 - 2017-01-02 05:50 AM - Giovanni Manghi

- Category changed from 44 to Processing/QGIS

#11 - 2017-01-04 11:40 PM - Giovanni Manghi

- Priority changed from High to Normal

#12 - 2017-05-01 01:09 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No
#13 - 2018-02-26 08:48 AM - Alexander Bruy

- Duplicated by Bug report #18212: Voronoi creates overlapping polygons added

#14 - 2018-02-27 02:36 PM - Erik Sigra

This is a confirmation that the bug is still reproducible in QGIS 3.0.0.

#15 - 2018-02-27 03:58 PM - Giovanni Manghi

- Description updated

- Affected QGIS version changed from master to 3.0.0

#16 - 2018-08-07 08:52 PM - Håvard Tveite

- % Done changed from 0 to 100

- Status changed from Reopened to Closed

Applied in changeset commit:qgis|28fa839a0835af450cd3eaf3b1316b5433da46ea.

#17 - 2018-08-08 10:21 AM - Håvard Tveite

With the applied changeset, there are still issues with overlapping polygons for the airports dataset.  https://github.com/qgis/QGIS/pull/7566 adds more

numerically robust comparison, and that seems to solve the issue also for the airports dataset.

#18 - 2018-08-25 09:53 PM - Håvard Tveite

The pull request that fixed the airport dataset issue has been merged, so I suggest that this issue can be closed.

#19 - 2018-08-29 11:37 AM - Giovanni Manghi

- Resolution set to fixed/implemented

Files

garden-nodes.zip 1.84 KB 2013-06-05 dr -

voronoi-issue.png 139 KB 2013-06-05 dr -

london.geojson 2.73 KB 2013-09-05 Giles Collingwood

Capture2.PNG 186 KB 2013-09-05 Giles Collingwood

voronoi_errors.png 482 KB 2015-07-15 Andrew Bevitt

voronoi_patched.png 448 KB 2015-07-15 Andrew Bevitt

voronoi.patch 8.31 KB 2015-07-15 Andrew Bevitt
